-- $Id: FoldLambdaTests.hs,v 1.2 2013/03/17 18:17:50 leavens Exp leavens $
module FoldLambdaTests where
import Lambda
import Data.List
import FoldLambda
import Testing
main = do startTesting "FoldLambdaTests $Revision: 1.2 $" 
          errs <- composeTests testsInteger testsBool 0
          doneTesting errs
-- The following definitions are just for use in testing, not for you to write!
countVarrefs :: Exp -> Integer
countVarrefs = foldLambda (\v -> 1) (+) (\_ body -> (countVarrefs body))
fv :: Exp -> [String]  -- using union from Data.List
fv = foldLambda (\v -> [v]) union (\v body -> filter (/=v) (fv body))
bv :: Exp -> [String]  -- using union and intersect from Data.List
bv = foldLambda (\v -> []) union 
                (\v body -> (bv body) `union` ((fv body) `intersect` [v]))
-- End of example definitions for help in testing, start of test cases
testsInteger :: [TestCase Integer]
testsInteger = 
    [eqTest (countVarrefs (Varref "x")) "==" 1
    ,eqTest (countVarrefs (App (Varref "f") (Varref "x"))) "==" 2
    ,eqTest (countVarrefs (Lambda "x" (App (Varref "f") (Varref "x")))) "==" 2
    ,eqTest (countVarrefs (App (Lambda "x" (App (Varref "f") (Varref "x")))
                           (Varref "z"))) "==" 3  ]
testsBool :: [TestCase Bool]
testsBool = 
    [assertTrue (fv (Varref "x") == ["x"])
    ,assertTrue (fv (App (Varref "f") (Varref "x")) == ["f","x"])
    ,assertTrue (fv (Lambda "x" (App (Varref "f") (Varref "x"))) == ["f"])
    ,assertTrue (fv (App (Lambda "x" (App (Varref "f") (Varref "x")))
                           (Varref "z")) == ["f","z"])
    ,assertTrue (bv (Varref "z") == [])
    ,assertTrue (bv (App (Varref "g") (Varref "z")) == [])
    ,assertTrue (bv (Lambda "q" (App (Varref "h") (Varref "q"))) == ["q"])
    ,assertTrue (bv (Lambda "z" (App (Lambda "x" (App (Varref "f") (Varref "x")))
                           (Varref "z"))) == ["x","z"])   ]
